;    GRDB - debugger for dos with 32-bit extensions
;    Copyright (C) 1997-2004  David Lindauer
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
;    (for GNU General public license see file COPYING)
;
;    you may contact the author at:  mailto::camille@bluegrass.net
; 
;    or by snail mail at:
;
;    David Lindauer
;    850 Washburn Ave.  Apt #99
;    Louisville, KY 40222
;
; dpmi.ASM
;
; Function: dpmi handlers
;
; not very efficient, but, fast enough!
;
	;MASM MODE
	.MODEL SMALL
	.386
        public  initDPMI, rundownDPMI

include eints.inc
include ehistory.inc
include eloader.inc
include emtrap.inc
include ebreaks.inc

        .code
startDPMI       dd      0
old85           dd      0
replaceStart    dw      0
codeAlias       dw      ?
dataSelector    dw      ?
codeSelector    dw      ?
allSelector     dw      ?
oldintpage      dw      ?
oldhistseg      dw      ?
oldstackseg     dw      ?
oldpsp          dw      ?
olduserbasepsp  dw      ?
gb4desc db      0ffh,0ffh,0,0,0,0F2h,0cfh,0
dpmiEnabled     db      0
dpmiType        db      0       ; 1 = 32 bit
dpmiHooked      db      0
;
; we have to hook the DPMI transition code directly because
; Win9x does this by intercepting the int 2fH in pmode and we
; can't rely on the DOS chain for this
;
initDPMI        PROC
        push    es
        mov     ax,1687h
        int     2fh
        and     ax,ax
        jnz     idx
        mov     word ptr [startDPMI],di
        mov     word ptr [startDPMI+2],es
        mov     ax,es:[di]
        mov     [replacestart],ax
        mov     word ptr es:[di],85cdh
        sub     ax,ax
        mov     es,ax
        les     ax,es:[85h*4]
        mov     word ptr [old85],ax
        mov     word ptr [old85 + 2],es
        sub     ax,ax
        mov     es,ax
        mov     word ptr es:[85h*4],offset ourStartHook
        mov     word ptr es:[85h*4+2],cs
        inc     dpmiHooked
        pop     es
idx:
        ret
initDPMI        ENDP
rundownDPMI     PROC
        test    [dpmiHooked],0ffh
        jz      rdx
        push    es
        sub     ax,ax
        mov     es,ax
        mov     ax,word ptr [old85]
        mov     word ptr es:[85h*4],ax
        mov     ax,word ptr [old85+2]
        mov     word ptr es:[85h*4+2],ax
        les     di,[startDPMI]
        mov     ax,[replaceStart]
        mov     word ptr es:[di],ax
rdx:
        pop     es
        ret
rundownDPMI     ENDP
;
; our replacement for the DPMI stack's startup routine
;
hidave  db      "hi dave$"
ourStartHook PROC
        add     sp,6    ; get around the 'int 85h'
        push    ax
        push    di
        push    es
        les     di,[startDPMI]
        mov     ax,[replaceStart]
        mov     word ptr es:[di],ax
        pop     es
        pop     di
        pop     ax
        pusha
        push    ds
        mov     dx,offset hidave
        push    cs
        pop     ds
        mov     ah,9
        int     21h
        pop     ds
        popa
        jmp     [startDPMI]
        call    [startDPMI]
        jc      startErr

        pushad
        mov     ebp,esp
        mov     bx,[ebp + 8 * 4 + 2]
        mov     ax,2            ; segment to selector
        int     31h

        ; win32 MAY return DS... check for it
        mov     bx,ds
        cmp     ax,bx
        jnz     gotcsretsel

        ; ok we have reused DS, get an alias for that now...
        mov     bx,ax
        mov     ax,0ah          ; get alias
        int     31h

gotcsretsel:
        mov     [ebp + 8 * 4 + 2],ax

        mov     bx,ax
        mov     cl,9ah + 60h ; code seg at DPL 3
        mov     ch,0
        mov     ax,9            ; set access rights
        int     31h        

; now start in on the GRDB - specific initialization

        push    ds
        push    es
        ; make an alias for our DGROUP

        mov     bx,dgroup
        mov     ax,2            ; seg 2 sel
        int     31h            
        mov     bx,ax
        mov     ax,0ah          ; get alias
        int     31h
        mov     ds,ax

        ; and a writeable alias for our CS
        mov     bx,cs
        mov     ax,0ah
        int     31h
        mov     es,ax

        ; save things for later
        mov     es:[codeAlias],es
        mov     es:[dataSelector],ds
        mov     es:[codeSelector],cs
        inc     es:[dpmiEnabled]
        mov     eax,[ebp + 7*8]
        and     eax,1
        mov     es:[dpmitype],al
        
; create a selector to access all 4 GB

        mov     cx,1
        mov     ax,0            ; allocate a selector
        int     31h
        
        mov     [allSelector],ax
        mov     bx,ax
        lea     edi,[gb4desc]
        mov     ax,0ch
        int     31h

; create a selector for the stack
        mov     bx,[stackseg]
        mov     [oldstackseg],bx
        mov     ax,2                    ; sel to desc
        int     31h
        mov     [stackseg],ax

; create a selector for the history
        mov     bx,[histseg]
        mov     [oldhistseg],bx
        mov     ax,2                    ; sel to desc
        int     31h
        mov     [histseg],ax

; create a selector for the intpage
        mov     bx,[intpage]
        mov     [oldintpage],bx
        mov     ax,2                    ; sel to desc
        int     31h
        mov     [intpage],ax

; create a selector for the GRDB psp
        mov     bx,[psp]
        mov     [oldpsp],bx
        mov     ax,2                    ; sel to desc
        int     31h
        mov     [psp],ax

; create a selector for the user psp
        mov     bx,[userbasepsp]
        mov     [olduserbasepsp],bx
        mov     ax,2                    ; sel to desc
        int     31h
        mov     [ebp-8],ax              ; return correct PSP to caller in ES
        mov     [userbasepsp],ax

        mov     [breakenum],0           ; clear all breakpoints
                                        ; breaks rm/pm shared segments tho

        pop     es
        pop     ds
        popad
        clc
startErr:
        ret
ourStartHook ENDP
        end
